{   }
unit shpic_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Image1: TImage;     //   
    Button1: TButton;   //  
    Label1: TLabel;
    Edit1: TEdit;
    RadioButton1: TRadioButton;  // : bmp - 
    RadioButton2: TRadioButton;  // : jpg - 
    GroupBox1: TGroupBox;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);

    //     
    procedure FirstPicture; //   
    procedure NextPicture;  //   
    procedure ScaleImage;   //  

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  iw,ih: integer; //    Image

implementation

{$R *.DFM}
uses
     jpeg; //    
           // jpg - 

var
  aSearchRec : TSearchRec;

  aPath: String[128]; // ,    
  aFile: String[128]; //  
  aMask: String[5];   //   
  n: integer = 0;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Image1.AutoSize := False;
    Image1.Stretch := True;     //  

    //      
    iw := Image1.Width;
    ih := image1.Height;

    Button1.Enabled := False; //    
    FirstPicture; //   
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
        if DirectoryExists(Edit1.Text)
            then FirstPicture
            else ShowMessage(' '+
            Edit1.Text +'  .');
end;

//   
procedure TForm1.FirstPicture;
var
   r : integer; //   
begin
   aPath := Edit1.Text;
   if aPath[Length(aPath)] <> '\'
        then aPath := aPath + '\';
   if RadioButton1.Checked
        then aMask := '*.bmp'
        else aMask := '*.jpg';
   r := FindFirst(aPath + aMask, faAnyFile, aSearchRec);
   if r = 0 then
      begin
          aFile := aPath + aSearchRec.Name;
          Image1.Picture.LoadFromFile(aFile); //  
          ScaleImage;
          r := FindNext(aSearchRec); //   
          if r = 0 then  //    
             Button1.Enabled := True;
      end;
end;

//   
Procedure TForm1.NextPicture();
var
   r : integer;
begin
   aFile := aPath + aSearchRec.Name;
   Image1.Picture.LoadFromFile(aFile);
   ScaleImage;

   //    
   r := FindNext(aSearchRec); //   
   if r <> 0
      then //   
         Button1.Enabled := False;
end;

//    
procedure TForm1.Button1Click(Sender: TObject);
begin
    NextPicture;
end;

//      
//  
Procedure Tform1.ScaleImage;
var
    pw, ph : integer;      //  
    scaleX, scaleY : real; //   X  Y
    scale : real;          // 
begin
      //   
      //   
      pw := Image1.Picture.Width;
      ph := Image1.Picture.Height;
      if pw > iw //      Image
          then scaleX := iw/pw  //  
          else scaleX := 1;
      if ph > ih //  .   
          then scaleY := ih/ph  //  
          else scaleY := 1;

      //   
      if  scaleX < scaleY
          then scale := scaleX
          else scale := scaleY;

      //     
      Image1.Height := Round(Image1.Picture.Height*scale);
      Image1.Width := Round(Image1.Picture.Width*scale);
      //   Strech = True    
      //  ,     
end;

//  bmp 
procedure TForm1.RadioButton1Click(Sender: TObject);
begin
    FirstPicture;
end;

//  jpg 
procedure TForm1.RadioButton2Click(Sender: TObject);
begin
    FirstPicture;
end;

end.
